
#------- Structure -------- 

#
# Table structure for table `InterfaceItemValues`
#

DROP TABLE IF EXISTS InterfaceItemValues;
CREATE TABLE InterfaceItemValues (
  InterfaceItemValueID int(11) NOT NULL auto_increment,
  InterfaceItemID int(11) default NULL,
  LanguageID int(11) default NULL,
  InterfaceItemValue text NOT NULL,
  PRIMARY KEY  (InterfaceItemValueID),
  KEY IX_Interface_Item_Search (InterfaceItemID,LanguageID)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `InterfaceItems`
#

DROP TABLE IF EXISTS InterfaceItems;
CREATE TABLE InterfaceItems (
  InterfaceItemID int(11) NOT NULL auto_increment,
  InterfaceItemName varchar(64) NOT NULL default '',
  InterfaceItemGroup varchar(64) default NULL,
  PRIMARY KEY  (InterfaceItemID),
  KEY IX_ItemName (InterfaceItemName),
  KEY IX_ItemGroup (InterfaceItemGroup)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `Languages`
#

DROP TABLE IF EXISTS Languages;
CREATE TABLE Languages (
  LanguageID int(11) NOT NULL auto_increment,
  LanguageName varchar(250) NOT NULL default '',
  Encoding varchar(64) default NULL,
  PRIMARY KEY  (LanguageID),
  KEY IX_LanguageName (LanguageName)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `LinkCategories`
#

DROP TABLE IF EXISTS LinkCategories;
CREATE TABLE LinkCategories (
  LinkCategoryID int(11) NOT NULL auto_increment,
  LinkCategoryName varchar(128) NOT NULL default '',
  PRIMARY KEY  (LinkCategoryID),
  KEY IX_Category_Search (LinkCategoryID,LinkCategoryName)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `Links`
#

DROP TABLE IF EXISTS Links;
CREATE TABLE Links (
  LinkID int(11) NOT NULL auto_increment,
  LinkCategoryID int(11) default NULL,
  Title varchar(128) NOT NULL default '',
  Description text NOT NULL,
  URL text NOT NULL,
  EMail varchar(128) NOT NULL default '',
  GraphicalURL text,
  ReciprocalURL text,
  LinkStatus enum('Review','Approved','Generated','SelfAdd','OffSite','Old','OldAccepted') NOT NULL default 'Review',
  SelfAdded tinyint(4) default '0',
  SubmitDate datetime NOT NULL default '0000-00-00 00:00:00',
  Rating float NOT NULL default '50',
  LastOffsiteCheck datetime default NULL,
  LastCheckStarted datetime default NULL,
  PRIMARY KEY  (LinkID),
  KEY IX_LinkStatus (LinkStatus,URL(128)),
  KEY IX_Status_CategoryID (LinkStatus,LinkCategoryID),
  KEY IX_Select (LinkStatus,LinkCategoryID,Rating,Title),
  KEY IX_OffSite_Checking (LinkStatus,LastOffsiteCheck,ReciprocalURL(128))
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `Registry`
#

DROP TABLE IF EXISTS Registry;
CREATE TABLE Registry (
  RegistryKey varchar(64) NOT NULL default '',
  KeyValue varchar(250) NOT NULL default '',
  PRIMARY KEY  (RegistryKey)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `Users`
#

DROP TABLE IF EXISTS Users;
CREATE TABLE Users (
  UserID int(11) NOT NULL auto_increment,
  UserName varchar(32) NOT NULL default '',
  UserPassword varchar(32) NOT NULL default '',
  PRIMARY KEY  (UserID),
  KEY IX_Auth (UserName,UserPassword)
) TYPE=MyISAM;

